// HEA_SETTINGS
db.settings.createIndex({user: 1, name: 1}, {name: "idx_settings_user_and_name", unique: true, partialFilterExpression: {$and: [{user: {$exists: true}}, {user: {$type: "string"}}, {name: {$exists: true}}, {name: {$type: "string"}}]}});
db.components.insertOne({type: "heaobject.registry.Component", created: new ISODate(), name: "heaserver-settings", description: "Settings", display_name: "HEA Settings Service", base_url: "http://heaserver-settings:8080", owner: 'system|none', shares: [{type: "heaobject.root.ShareImpl", user: 'system|all', permissions: ["VIEWER"]}], resources: [{type: "heaobject.registry.Resource", resource_type_name: "heaobject.settings.SettingsObject", resource_collection_type_display_name: "Settings", file_system_type: "heaobject.volume.MongoDBFileSystem", base_path: "settings"}]});

// Assign display names to existing resources.
db.components.updateOne({name: 'heaserver-trash-aws-s3'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Trash'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.trash.AWSS3FolderFileTrashItem'}]});
db.components.updateOne({name: 'heaserver-storage'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Storage'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.storage.AWSStorage'}]});
db.components.updateOne({name: 'heaserver-activity'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Activity'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.activity.DesktopObjectAction'}]});
db.components.updateOne({name: 'heaserver-files-aws-s3'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Files'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.data.AWSS3FileObject'}]});
db.components.updateOne({name: 'heaserver-folders-aws-s3'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Folders'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.folder.AWSS3Folder'}]});
db.components.updateOne({name: 'heaserver-folders-aws-s3'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Projects'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.project.AWSS3Project'}]});
db.components.updateOne({name: 'heaserver-folders-aws-s3'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Items'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.folder.AWSS3Item'}]});
db.components.updateOne({name: 'heaserver-buckets'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Buckets'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.bucket.AWSBucket'}]});
db.components.updateOne({name: 'heaserver-buckets'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS S3 Bucket Items'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.folder.AWSS3BucketItem'}]});
db.components.updateOne({name: 'heaserver-accounts'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'AWS Accounts'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.account.AWSAccount'}]});
db.components.updateOne({name: 'heaserver-volumes'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Volumes'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.volume.Volume'}]});
db.components.updateOne({name: 'heaserver-filesystems'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'File Systems'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.volume.FileSystem'}]});
db.components.updateOne({name: 'heaserver-keychain'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Credentials'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.keychain.Credentials'}]});
db.components.updateOne({name: 'heaserver-people'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'People'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.person.Person'}]});
db.components.updateOne({name: 'heaserver-data-adapters'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Data Adapters'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.dataadapter.DataAdapter'}]});
db.components.updateOne({name: 'heaserver-folders'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'MongoDB Folders'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.folder.Folder'}]});
db.components.updateOne({name: 'heaserver-folders'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'MongoDB Folder Items'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.folder.Item'}]});
db.components.updateOne({name: 'heaserver-organizations'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Organizations'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.organization.Organization'}]});
db.components.updateOne({name: 'heaserver-registry'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Components'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.registry.Component'}]});
db.components.updateOne({name: 'heaserver-registry'}, {$set: {'resources.$[e1].resource_collection_type_display_name': 'Properties'}}, {arrayFilters: [{'e1.resource_type_name': 'heaobject.registry.Property'}]});

// Add collection resource to the heaserver-registry component.
db.components.updateOne({name: 'heaserver-registry'}, {$push: {'resources': {type: 'heaobject.registry.Resource', resource_type_name: 'heaobject.registry.Collection', base_path: 'collections', resource_collection_type_display_name: 'Collections'}}});